import java.awt.event.*;
import java.util.ArrayList;

/**
 * Vorlage Kapitel 1.6 - Einstiegsaufgabe: MemoApp zum Speichern von Notizen
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
 class MemoApp extends Methodenbox
{

    ArrayList<String> alleNotizen;  

    /**
     * Diese Methode wird beim Erzeugen eines Objekts automatisch aufgerufen (Konstruktor).
     * Nicht Löschen, weil darüber der Startbildschirm aufgebaut wird.
     */
    MemoApp()
    {
        starteApp();
    }
    
    /**
     * Methode starteApp richtet Schaltflächen und Textfelder auf der Oberfläche ein und
     * fügt 4 Notizen ein.
     *
     */
    void starteApp()
    {
        fuegeBildHinzu("ButtonPlus", "bilder/Plus.png", 50, 500, 50, 50);
        fuegeBildHinzu("ButtonListe", "bilder/Liste.png", 125, 500, 50, 50);
        fuegeBildHinzu("ButtonInformation", "bilder/Information.png", 200, 500, 50, 50);
        fuegeBildHinzu("ButtonKreuz", "bilder/Kreuz.png", 275, 500, 50, 50);

        fuegeTextHinzu("TextfeldNotizen","" , 20, 50, 600, 380);

        fuegeTextHinzu("Eingabefeld","Hier bitte Text einer neuen Notiz bzw. Index der gewünschten Notiz eingeben." , 20, 440, 600, 50);
        setzeSchreibbarkeit("Eingabefeld", true);
        setzeHintergrundfarbe("Eingabefeld", 200, 200, 255);

        alleNotizen = new ArrayList<String>();
        alleNotizen.add("Eis essen mit Charlotte");
        alleNotizen.add("Schwimmzeug einpacken");
        alleNotizen.add("Oma anrufen");
        alleNotizen.add("Obst und Schoko kaufen");
    }

    /**
     * Methode NotizHinzufügen fügt eine Notiz mit dem Inhalt aus dem Eingabefeld hinzu.
     *
     */
    void NotizHinzufügen()
    {
        String neueNotiz;
        neueNotiz = gibTextinhalt("Eingabefeld");
        alleNotizen.add(neueNotiz);
        ersetzeText("TextfeldNotizen", "Notiz wurde hinzugefügt.");
        ersetzeText("Eingabefeld", "Hier bitte Text einer neuen Notiz bzw. Index der gewünschten Notiz eingeben."); 

    }

    /**
     * Methode AlleNotizenAnzeigen zeigt alle Notizen im Textfeld an.
     *
     */
    void AlleNotizenAnzeigen()
    {
        String ausgabe;
        ausgabe = "";
        String trennzeile;
        trennzeile = "-------------------";
        for(String notiz: alleNotizen)
        {
            ausgabe = ausgabe + notiz + "\n" + trennzeile + " \n";
        }

        ersetzeText("TextfeldNotizen", ausgabe);
        ersetzeText("Eingabefeld", "Hier bitte Text einer neuen Notiz bzw. Index der gewünschten Notiz eingeben."); 

    }

    /**
     * Methode EineNotizAnzeigen zeigt die älteste Notiz an.
     *
     */
    void EineNotizAnzeigen()
    {
          if(alleNotizen.size()>0 )
            {
                ersetzeText("TextfeldNotizen", alleNotizen.get(0));

            }
            else
            {
                ersetzeText("TextfeldNotizen", "Keine Notizen vorhanden!");
            }

    }

    /**
     * Methode EineNotizLöschen löscht die Notiz, deren Index im Eingabefeld steht.
     *
     */
    void EineNotizLöschen()
    {
        if(istEintragEineZahl("Eingabefeld"))
        {
            int zahl;
            zahl = Integer.parseInt(gibTextinhalt("Eingabefeld"));
            if(zahl < alleNotizen.size() )
            {
                alleNotizen.remove(zahl);

                ersetzeText("TextfeldNotizen", "Notiz wurde gelöscht.");
                ersetzeText("Eingabefeld", "Hier bitte Text einer neuen Notiz bzw. Index der gewünschten Notiz eingeben."); 

            }
            else
            {
                ersetzeText("TextfeldNotizen", "");
                ersetzeText("Eingabefeld", "Eine Nachricht zu diesem Index existiert nicht."); 
            }
        }
        else
        {
            ersetzeText("TextfeldNotizen", "");
            ersetzeText("Eingabefeld", "Bitte hier Index als Notiznummer eingeben und nochmal den Schaltknopf drücken."); 
        }

    }

    /**
     * Methode EineNachrichtLöschen löscht die Nachricht an, deren Index im Eingabefeld steht.
     *
     */
    void AlleNotizenLöschen()
    {
        //toDo

    }

    /**
     * Reaktion, wenn Schaltknopf angeklickt (Maus losgelassen) wurde
     */
    @Override public void mouseReleased(MouseEvent e)
    {
      //Klick auf Button +
        if(e.getX()>60 && e.getX()<100 && e.getY()>530 && e.getX()<570)
        {
            NotizHinzufügen();
        }
        //Klick auf Button Liste
        if(e.getX()>135 && e.getX()<185 && e.getY()>530 && e.getX()<570)
        {
            AlleNotizenAnzeigen();
        }
        //Klick auf Button i
        if(e.getX()>200 && e.getX()<250 && e.getY()>530 && e.getX()<570)
        {
            EineNotizAnzeigen();
        }
        //Klick auf Button Kreuz
        if(e.getX()>275 && e.getX()<325 && e.getY()>530 && e.getX()<570)
        {
            EineNotizLöschen();
        }
        //Klick auf Button rotes Kreuz, wenn es passend hinzugefügt ist
        if(e.getX()>350 && e.getX()<400 && e.getY()>530 && e.getX()<570)
        {
            
        }

    }

}
