import java.util.ArrayList;

/**
 * Vorlage Kapitel 1.6 - Aufgabe 11: Klasse EKG_Auswertung zur Auswerten von EKG-Daten
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
public class EKG_Auswertung extends Methodenbox
{
    /** Speicherung der Spannungswerte in mV*/
    private ArrayList<Integer> daten;
    /** Zeitabstand zwischen zwei Messwerten in Millisekunden*/
    private int zeitabstand; 
    /** Speicherung der Maxima in zwei Listen: eine für die Zeitwerte, eine für die Spannungswerte.
     * Über den Index kann passend zugeordnet werden*/
    private ArrayList<Integer> zeitpunkteLokalerMaxima;
    private ArrayList<Integer> lokaleMaxima;

    /**
     * ACHTUNG: Eine Initialisierung ist notwendig vor dem Aufruf anderer Methoden: 
     * Erzeugen der ArrayLists
     * Einlesen von Daten (hier Spannungswerte in mV) aus einer Datei
     * Ausgabe der eingelesenen Daten
     */
    public void initialisiere()
    {
        daten = new ArrayList<Integer>();
        daten = datenAusDateiLesen("EKG_Datenreihe.csv");

        zeitabstand = 2;  
        zeitpunkteLokalerMaxima = new ArrayList<Integer>();
        lokaleMaxima = new ArrayList<Integer>();

        gibDatenreiheAus();
    }

    /**
     * Ausgabe einer Messreihe mit Zeitpunkt in ms und Spannung in mV
     */
    private void gibDatenreiheAus()
    {
        for(int index = 0; index < daten.size(); index = index + 1)
        {
            System.out.println(index * 2 + " ms:   " + daten.get(index) + " mV");
        }
    }

    /**
     * Zeichnung der Messreihe
     */
    public void zeichneMessreihe()
    {
        for(int index = 0; index < daten.size(); index = index + 1)
        {
            zeichnePunkt(index, daten.get(index));  //Die Verbesserung für a) muss in der Methode zeichnePunkt gesucht werden.
        }
    }

    /**
     * Methode zeichnePunkt bewegt die Turtle zu der angegebenen Position und zeichnet
     * dort einen Messpunkt in Form eines Quadrats mit der Seitenlänge 2 Pixel
     *
     * @param x x-Wert
     * @param y Da die y-Achse nach unten gerichtet ist, wird das 
     *          Vorzeichen des y-Werts (in der Methode geheZuPosition) invertiert.
     */
    public void zeichnePunkt(int x, int y)
    {
        setzePosition(x, - y);

        senkeStift();
        for(int i = 1; i <= 4; i = i + 1)
        {
            gehe(2);
            drehe(90);
        }
        hebeStift();

    }

    /**
     * Bestimmt den Maximalwert der Messreihe und gibt ihn aus
     * 
     */
    public void bestimmeMaxSpannung()
    {
        //toDo
    }

    /**
     * Ermittelt die maximalen Spannungswerte innerhalb der QRS-Komplexe und deren Zeitpunkte 
     * und speichert diese in den Attributen zeitpunkteLokalerMaxima bzw. lokaleMaxima.
     * 
     */
    public void bestimmeMaxima()
    {
        int maximumSpannung = 0;
        maximumSpannung = 0;
        int zeitpunktMaximum;
        zeitpunktMaximum = 0;
        int anzahlFallendeWerte;
        anzahlFallendeWerte = 0;

        zeitpunkteLokalerMaxima.clear();
        lokaleMaxima.clear();

        int index = 0;
        while(index < daten.size())
        {
            if(daten.get(index) > 300)  // es werden nur Maxima der QRS-Komplexe gesucht -> Schwellwert muss überschritten sein!
            {
                if(daten.get(index) > maximumSpannung)  
                {
                    maximumSpannung = daten.get(index);
                    zeitpunktMaximum = index * zeitabstand;
                }
                else
                {
                    anzahlFallendeWerte = anzahlFallendeWerte + 1;  //Anzahl der Schritte nach unten werden gezählt
                    if(anzahlFallendeWerte > 3)   // bei mehr als drei Schritten war es kein Ausreißer -> lokales Maximmum gefunden!
                    {
                        zeitpunkteLokalerMaxima.add(zeitpunktMaximum);
                        lokaleMaxima.add(maximumSpannung); 
                        System.out.println("Maximum Nr. " + lokaleMaxima.size() + " bei " + zeitpunktMaximum + "ms  / " +  maximumSpannung + "mV");
                        index = index + 50;         // 100 ms nach vorne springen
                        zeitpunktMaximum = 0;       // temporäre Variablen zurücksetzen
                        maximumSpannung = 0;        // temporäre Variablen zurücksetzen
                    }
                }
            }    
            index = index + 1;
        }

    }

    /**
     * Bestimmung der Anzahl der Herzschläge pro Minute und Ausgabe auf der Konsole
     */
    public void gibHerzschlägeProMinuteAus()
    {
         //toDo
 
    }            
}
