import java.util.ArrayList;

/**
 * Vorlage Kapitel 1.6 - Aufgabe 8: Klasse CoronaStatistik zur Darstellung von Corona Daten aus den Jahren 2020 und 2021
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
public class CoronaStatistik extends Methodenbox
{
    /** Speicherung der Personenanzahl pro Tag im Jahr -> 10.Zahl ist vom 10. Januar*/
    private ArrayList<Integer> neuinfizierteProTag;
    private ArrayList<Integer> todesfälleProTag;

    int SkalierungXAchse;
    int SkalierungYAchse;

    /**
     * ACHTUNG: Initialisierung, ist notwendig vor dem Aufruf anderer Methoden: 
     * Erzeugen der ArrayLists
     * Einlesen von Daten aus einer Datei
     * Für Teilaufgabe f müssen hier die Daten von 2021 eingelesen (und später die Skalierung verändert werden)
     * Ausgabe der eingelesenen Daten
     */
    public void initialisiere()
    {
        neuinfizierteProTag = new ArrayList<Integer>();
        neuinfizierteProTag = datenAusDateiLesen("NeuinfizierteProTag2020.csv");
        todesfälleProTag = new ArrayList<Integer>();
        todesfälleProTag = datenAusDateiLesen("TodesfaelleProTag2020.csv");

        DatenreiheAusgeben();
    }

    /**
     * Ausgabe der neu Infizierten und Todesfälle pro Tag
     */
    public void DatenreiheAusgeben()
    {
        for(int index = 0; index < neuinfizierteProTag.size(); index = index + 1)
        {
            System.out.println("Tag: " + (index +1) + " neu Infizierte:  " + neuinfizierteProTag.get(index) + " Todesfälle: " + todesfälleProTag.get(index) );
        }
    }

    /**
     * Methode zeichneKoordinatensystem zeichnet ein Koordinatensystem
     * Beachte: In Abweichung zur Aufgabenstellung d) ist die Skalierung der Achsen ausreichend. 
     * Eine Beschriftung ist in Java schwer umsetzbar, deshalb wird darauf verzichtet.
     *
     */
    public void zeichneKoordinatensystem()
    {
        setzeFarbe("schwarz");

        //xAchse
        SkalierungXAchse = 30; // senkrechter Strich alle 30 Einheiten -> ca. 1 Monat
        setzePosition(50, 500); // Ursprung 
        setzeRichtung(0);
        senkeStift();
        gehe(400);
        hebeStift();
        setzePosition(50, 500);
        for(int i = 1; i <= 400/SkalierungXAchse; i = i+1)
        {
            setzePosition(50 + i*SkalierungXAchse,500);
            zeichneMaßeinheit();
        }

        //yAchse
        SkalierungYAchse = 50; // senkrechter Strich alle 50 Einheiten 
        setzePosition(50, 500);
        setzeRichtung(90);
        senkeStift();
        gehe(450);
        setzePosition(50, 500);
        for(int i = 1; i <= 450 / SkalierungYAchse; i = i+1)
        {
            setzePosition(50, 500 - i*SkalierungYAchse);
            zeichneMaßeinheit();
        }
    }

    /**
     * Methode zeichneMaßeinheit ist eine Hilfsfunktion zum Einzeichnen der 
     * Skala auf den Koordinatenachsen
     */
    private void zeichneMaßeinheit()
    {
        hebeStift();
        drehe(-90);
        gehe(10);
        drehe(180);
        senkeStift();
        gehe(20);
        hebeStift();
        gehe(10);
        drehe(90);
    }

    /**
     * Zeichnung der Neuinfizierten pro Tag
     */
    public void zeichneNeuinfizierte()
    {
        //toDo
        // Hinweise
        // über die Methode setzePosition(xNeu, yNeu) kann die Turtle bewegt werden
        // beachte der Koordinatenursprung liegt bei (50, 500) und die y-Werte auf der Zeichenfläche nehmen nach unten zu 
        // Ein Messpunkt kann z. B. durch Zeichnen eines Quadrats mit der Seitenlänge 2 Pixel gezeichnet werden
        // über setzeFarbe(farbeNeu) kann die Farbe durch Eingabe eine Zeichenkette wie "rot" oder "blau" verändert werden
        //
    }

    /**
     * Zeichnung der Todesfälle pro Tag
     */
    public void zeichneTodesfälle()
    {
        //toDo
    }

    
    /**
     * Bestimmt den Maximalwert der Messreihe und gibt ihn aus
     * 
     */
    public void bestimmeMaximumNeuinfizierte()
    {
        //toDo
    }

    

}
