import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.ArrayList;

import java.util.ArrayList;
/**
 * Methodenbox für für 1.6.11 EKG Auswertung
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
public class Methodenbox
{
    private Dateileser dateileser;
    private Turtle turtle;
    /**
     * Konstruktor für Objekte der Klasse Methodenbox
     */
    public Methodenbox()
    {
        turtle = new Turtle();
        System.out.println("ACHTUNG: Eine Initialisierung ist notwendig vor dem Aufruf anderer Methoden.");
        System.out.println("Rufen Sie zuerst die Methode initialisiere() auf.");
        System.out.println("Danach folgen typischerweise:");
        System.out.println("zeichneKoordinatensystem()");
        System.out.println("zeichneNeuinfizierte()"); 
        System.out.println("zeichneTodesfälle()"); 
        System.out.println("bestimmeMaximumNeuinfizierte()"); 
 
    }

    public ArrayList<Integer> datenAusDateiLesen(String dateiname)
    {
        ArrayList<Integer> ergebnis;
        ergebnis = new ArrayList<Integer>();
        dateileser = new Dateileser(dateiname);
        ergebnis = dateileser.ZahlenAuslesen();

        return ergebnis;

    }

    public void setzePosition(int x, int y)
    {
        turtle.PositionSetzen(x,y);
    }

    public void gehe(int Schritte)
    {
        turtle.Gehen(Schritte);
    }

    public void drehe(int Grad)
    {
        turtle.Drehen(Grad);
    }

    public void hebeStift()
    {
        turtle.StiftHeben();
    }

    public void senkeStift()
    {
        turtle.StiftSenken();
    }

    public void setzeRichtung(int Winkel)
    {
        turtle.WinkelSetzen(Winkel);
    }
    
    public void setzeFarbe(String farbe)
    {
        turtle.FarbeSetzen(farbe);
    }

    /**
     * Mit der Klasse Dateileser kann eine einspaltige csv-Datei ausgelesen werden.
     * 
     * @author Peter Brichzin
     * @version 1.0
     */
    private class Dateileser
    {
        private String dateiname; 
        private File datei;
        private ArrayList<Integer> daten;

        /**
         * Konstruktor für Objekte der Klasse Dateileser
         * @param  dateinameNeu    neuer Dateiname
         */
        public Dateileser(String dateinameNeu)
        {
            dateiname = dateinameNeu;
            datei = new File(dateiname);
            daten = new ArrayList<Integer>();
        }

        /**
         * Setzt den Wert von Dateiname
         * @param  dateinameNeu    neuer Dateiname
         */
        public void DateinameSetzen(String dateinameNeu)
        {
            datei = new File(dateinameNeu);
        }

        /**
         * Liest ganzzahlige Werte in das Feld ein und gibt das Feld zurück.
         * @return Feld mit den Messwerten
         */
        public ArrayList<Integer> ZahlenAuslesen()
        {
            daten.clear();
            try
            {
                Scanner inputStream = new Scanner(datei);

                while(inputStream.hasNextInt())
                {
                    int zahl = inputStream.nextInt();
                    daten.add(zahl);
                }

                inputStream.close();
            }
            catch (FileNotFoundException e)
            {
                e.printStackTrace();
            }
            return daten;
        }

        /**
         * Liest ganzzahlige Werte in das Feld ein und gibt die Werte aus.
         */
        public void ZahlenAuslesenUndAnzeigen()
        {
            daten.clear();
            try
            {
                Scanner inputStream = new Scanner(datei);

                while(inputStream.hasNextInt())
                {
                    int zahl = inputStream.nextInt();
                    daten.add(zahl);
                    System.out.println(zahl);
                }

                inputStream.close();
            }
            catch (FileNotFoundException e)
            {
                e.printStackTrace();
            }
        }
    }

}
