import java.util.ArrayList;

/**
 * Vorlage Kapitel 1.6 - Aufgabe 9: Klasse Textanimation zur Erzeugung einer Laufschrift
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
class Textanimation extends Methodenbox
{
    /** Liste aus Wörtern*/
    private ArrayList<String> wörterliste; 
    /** Liste von Bezeichnern für Textfelder, von denen jedes ein Wort darstellt */
    private ArrayList<String> bezeichnerTextfeldListe; 

    /**
     * Diese Methode nicht Löschen. Sie garantiert beim Erzeugen des Objekts
     * die beiden (leeren) ArrayLists als Initialisierung (und verhindert damit den Fehler NullPointerException).
     */
    Textanimation()
    {
        wörterliste = new ArrayList<String>();
        bezeichnerTextfeldListe = new ArrayList<String>();
        System.out.println("Vor dem Aufruf von starteAnimation müssen über einen Aufruf von \n erzeugeTextfelderAusWörtern Textfelder erzeugt werden, die dann animiert werden.");

    }

    /**
     * Methode trenneNach trennt einen text in einzelne Wörter auf, wobei die Trennung
     * jeweils nach dem Trennzeichen erfolgt. Die einzelnen Wörter werden in 
     * der ArrayList wörterliste gespeichert.
     *
     * @param text 
     * @param trennzeichen 
     */
    void trenneNach(String text, String trennzeichen)
    {
        String[] wörterlisteAlsFeld; // leider muss in Java ein Umweg gegangen werden: 
        //Die Standardmethode zum Splitten hat als Ergebnis Feld und keine ArrayList als Datenstruktur. 
        // Vergleiche nach dem Initialisieren im Objektinspektor,dort sehen die beiden Datenstrukturen gleich aus.

        wörterlisteAlsFeld = text.split(trennzeichen); //Der Eingabewert " " bedeutet, die Wörter werden nach jedem Leerzeichen getrennt.

        //Jedes einzelne Wort aus der wörterlisteAlsFeld wird nun in die ArrayList wörterlisteAlsFeld hinzugefügt.
        for(String wort: wörterlisteAlsFeld)
        {
            wörterliste.add(wort);
        }

    }

    /**
     * Methode erzeugeTextfelderAusWörtern erzeugt für jedes Wort in der ArrayList wörterliste
     * ein Textfeld und speichert den Bezeichner in der ArrayList bezeichnerTextfeldListe
     *
     */
    void erzeugeTextfelderAusWörtern() 
    {
        String bezeichnerTextfeld;
        int xPos;
        xPos = 50;

        wörterliste.add("Info");
        wörterliste.add("ist");
        wörterliste.add("cool!");

        for(int i=0; i <= wörterliste.size()-1; i = i+1)
        {
            bezeichnerTextfeld = "w" + i;
            bezeichnerTextfeldListe.add(bezeichnerTextfeld);
            erzeugeWort(bezeichnerTextfeld, wörterliste.get(i), xPos , 100, "blau");
            xPos = xPos + wörterliste.get(i).length()*20;
        }

    }

    /**
     * Methode starteAnimation startet als Animation eine Laufschrift.
     * 
     * Zur Animation stehen aus der Oberklasse die Methoden
     * drehe(String bezeichner, int winkel)
     * verschiebe(String bezeichner, int x, int y)
     * sichtbarkeitSetzen(String bezeichner, boolean istSichtbar)
     * warte(int Millisekunden)
     * gibZufallszahl(int n)
     * zur Verfügung
     */
    void starteAnimation()
    {
        sichtbarkeitSetzen("w0", false);
        sichtbarkeitSetzen("w1", false);
        sichtbarkeitSetzen("w2", false);
        warte(1000);
        sichtbarkeitSetzen("w0", true);
        warte(1000);
        sichtbarkeitSetzen("w1", true);
        warte(1000);
        sichtbarkeitSetzen("w2", true);
        warte(1000);
        sichtbarkeitSetzen("w0", false);
        sichtbarkeitSetzen("w1", false);
        sichtbarkeitSetzen("w2", false);
        warte(1000);
        sichtbarkeitSetzen("w0", true);
        warte(1000);
        sichtbarkeitSetzen("w1", true);
        warte(1000);
        sichtbarkeitSetzen("w2", true);
        warte(1000);
    }


}
