import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.ArrayList;
import java.util.Random;

/**
 * Methodenbox für Kapitel 1.6.9 Laufschrift
 * 
 * @author Peter Brichzin
 * @version 1.0
 */
public class Methodenbox
{
    private ArrayList<Text> textfelder;
    private Random zzgenerator;
    /**
     * Der Konstruktor meldet den Taktgeber
     * und die Eventlistener bei der Zeichenfläche an.
     */
    Methodenbox ()
    {
        Zeichenfenster.AktionsEmpfängerEintragen(new Zeichenfenster.AktionsEmpfaenger()
            {
                public void Ausführen ()
                {
                    TaktImpulsAusführen();
                }

                public void Taste (char taste)
                {
                    TasteGedrückt(taste);
                }

                public void SonderTaste (int taste)
                {
                    SonderTasteGedrückt(taste);
                }

                public void Geklickt (int x, int y, int anzahl)
                {
                    MausGeklickt(x, y, anzahl);
                }
            });
        textfelder = new ArrayList<Text>();
         zzgenerator = new Random();
        
    }
    
    /**
     * Gibt eine Zufallszahl zurück aus dem Bereich von 0..n-1
     * @param n Anzahl der Werte im Zufallsbereich
     * @return Zufallszahl aus der Menge {0, ... , n-1}
     */
    int gibZufallszahl(int n)
    {
        return zzgenerator.nextInt(n);
    }

    /**
     * Die eigentliche Aktionsmethode des Zeitgebers.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     */
    void TaktImpulsAusführen ()
    {
        System.out.println ("Tick");
    }

    /**
     * Zeitgeber starten.
     */
    void Starten ()
    {
        Zeichenfenster.TaktgeberStarten();
    }

    /**
     * Zeitgeber anhalten.
     */
    void Anhalten ()
    {
        Zeichenfenster.TaktgeberStoppen();
    }

    /**
     * Ablaufgeschwindigkeit des Zeitgebers einstellen.
     * 
     * @param dauer: Angabe in Millisekunden
     */
    void TaktdauerSetzen (int dauer)
    {
        Zeichenfenster.TaktdauerSetzen(dauer);
    }

    /**
     * Die eigentliche Aktionsmethode für gedrückte Tasten.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param taste die gedrückte Taste
     */
    void TasteGedrückt (char taste)
    {
        System. out. println ("Taste: " + taste);
    }

    /**
     * Die eigentliche Aktionsmethode für gedrückte Sondertasten.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param taste KeyCode der gedrückten Taste
     */
    void SonderTasteGedrückt (int taste)
    {
        System. out. println ("Sondertaste: " + taste);
    }

    /**
     * Die eigentliche Aktionsmethode für einen Mausklick.
     * <br>Muss bei Bedarf von einer Unterklasse überschrieben werden. 
     * @param x x-Position des Mausklicks
     * @param y y-Position des Mausklicks
     * @param anzahl Anzahl der aufeinanderfolgenden Mausklicks
     */
    void MausGeklickt (int x, int y, int anzahl)
    {
        System. out. println ("Maus: (" + x + "|" + y + "), " + anzahl + " mal");
    }

    void erzeugeBuchstabe(String bezeichner, char c, int x, int y)
    {
        for(Text t: textfelder)
        {

            if(t.BezeichnerGeben().equals(bezeichner))
            {
                System.out.println("Bezeichner darf nicht doppelt vergeben werden."+
                    " Buchstabe nicht erzeugt");
                break;
            }
        }
        Text tneu = new Text(bezeichner);
        tneu.TextGrößeSetzen(100);
        tneu.TextSetzen(c+"");
        tneu.PositionSetzen(x, y);
        tneu.SichtbarkeitSetzen(true);
        textfelder.add(tneu);

    }
    
    void erzeugeWort(String bezeichner, String wort, int x, int y, String farbe)
    {
        for(Text t: textfelder)
        {

            if(t.BezeichnerGeben().equals(bezeichner))
            {
                System.out.println("Bezeichner darf nicht doppelt vergeben werden."+
                    " Buchstabe nicht erzeugt");
                break;
            }
        }
        Text tneu = new Text(bezeichner);
        tneu.TextGrößeSetzen(30);
        tneu.TextSetzen(wort);
        tneu.PositionSetzen(x, y);
        tneu.SichtbarkeitSetzen(true);
        tneu.FarbeSetzen(farbe);
        textfelder.add(tneu);

    }

    void drehe(String bezeichner, int winkel)
    {
        for (Text t: textfelder)
        {
            if (t.BezeichnerGeben().equals(bezeichner))
            {
                t.Drehen(winkel);
                break;
            }
        }

    }

    void verschiebe(String bezeichner, int x, int y)
    {
        for (Text t: textfelder)
        {
            if (t.BezeichnerGeben().equals(bezeichner))
            {
                t.Verschieben(x, y);
                break; 
            }
        }
    }
    
    void sichtbarkeitSetzen(String bezeichner, boolean istSichtbar)
    {
        for (Text t: textfelder)
        {
            if (t.BezeichnerGeben().equals(bezeichner))
            {
                t.SichtbarkeitSetzen(istSichtbar);
                break; 
            }
        }
    }
    
    void warte(int Millisekunden)
    {
        try {
            Thread.sleep(Millisekunden);
        } catch (InterruptedException e) {
            System.out.println("Thread is interrupted");
        }

    }
}
